#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif

#define PIN 6
//Define the pin connection for rotator
int CLK = 2;//CLK->D2
int DT = 3;//DT->D3
int SWr = 4;//SW->D4
const int interrupt0 = 0;// Interrupt 0 = pin 2 // Interrupt 1 = pin 3
int count = 0;//Define the count
int lastCLK = 0;//CLK initial value

// Arduino pin numbers
int SW = 1; // digital pin connected to switch output
int VRx = A0; // analog pin connected to X output
int VRy = A1; // analog pin connected to Y output

int xPosition = 0;  //x position raw
int yPosition = 0;  //y position raw
int SW_state = 1;   //Z position
int SW_state2 = 1;   //Z position
int mapX = 0;       // mapped value for x
int mapY = 0;       // mapped value for y

int row = 0;
int col = 0;
int pix = 0;
int j=0;
int i=0;
int pix_old=0;
int pix_old1=0;

boolean rotclick = true;

// Parameter 1 = number of pixels in strip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
//   NEO_RGBW    Pixels are wired for RGBW bitstream (NeoPixel RGBW products)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(40, PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  // put your setup code here, to run once:
  pinMode(SWr, INPUT);
  digitalWrite(SWr, HIGH);
  pinMode(CLK, INPUT);
  pinMode(DT, INPUT);
  attachInterrupt(interrupt0, ClockChanged, CHANGE);//Set the interrupt 0 handler, trigger level change
  //attachInterrupt(digitalPinToInterrupt(SWr), SWrChanged, CHANGE);
  strip.begin();
  strip.setBrightness(50);
  strip.show(); // Initialize all pixels to 'off'

  Serial.begin(9600); 
  
  pinMode(VRx, INPUT);
  pinMode(VRy, INPUT);
  pinMode(SW, INPUT_PULLUP); 
}

void loop() 
{
  // start color loop
  for  (i = 0; i< 256; i++){
      strip.clear();
      // read and map joystick values
      xPosition = analogRead(VRx);
      yPosition = analogRead(VRy);
      if (digitalRead(SWr)==0 && SW_state2 ==1) {
        rotclick = !rotclick;
        SW_state2 = 0;
      } else if (digitalRead(SWr)==1)
        { 
          SW_state2 = 1;
        }
      //SW_state2 = SW_state;
      mapX = map(xPosition, 0, 1021, 0, 7);
      mapY = map(yPosition, 0, 1021, 0, 4);
      // convert coordinate into specific pixel via math
      pix = mapY * 8;
      pix = pix + mapX;
      //light up pixel
      if ( rotclick == false){
        j = i;
      }
      strip.setPixelColor(pix, Wheel((pix+j) & 255));
      strip.setPixelColor(pix_old, Wheel((pix_old+j) & 255));
      strip.setPixelColor(pix_old1, Wheel((pix+j) & 255));
      strip.show();
      pix_old1=pix_old;
      pix_old= pix;
      delay(75);
  
  }
}
// //// ******** extra codes *******
//The interrupt handlers
void SWrChanged()
{
  //rotclick = !rotclick;
  Serial.print("rotclick:  ");
  Serial.println(rotclick);

}
void ClockChanged()
{
  int clkValue = digitalRead(CLK);//Read the CLK pin level
  int dtValue = digitalRead(DT);//Read the DT pin level
  if (lastCLK != clkValue)
  {
    lastCLK = clkValue;
    count += (clkValue != dtValue ? 1 : -1);//CLK and inconsistent DT + 1, otherwise - 1
    if (count > 255) {
      count = 255;
    } else if (count < 0 ) {
      count = 0;
    }
    j = count;
    //Serial.print("count:");
    //Serial.println(count);
  }
}
// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}
